% $Id: ConsecutiveTest.oz,v 1.3 2007/11/29 01:55:29 leavens Exp leavens $
\insert 'Consecutive.oz'
\insert 'SolveFirst.oz'
\insert 'SolveAll.oz'
\insert 'TestingNoStop.oz'

{StartTesting 'SolveAll forwards'}
{Test {SolveAll proc {$ Suffix} {Consecutive nil 1 2 Suffix} end}
 '==' nil}
{Test {SolveAll proc {$ Suffix} {Consecutive 1|2|nil 1 2 Suffix} end}
 '==' [nil]}
{Test {SolveAll proc {$ Suffix} {Consecutive [1 2 3] 1 2 Suffix} end}
 '==' [[3]]}
{Test {SolveAll proc {$ Suffix}
                   {Consecutive [7 1 2 3 2 0 1 2 5] 1 2 Suffix}
                end}
 '==' [[3 2 0 1 2 5] [5]]}
{Test {SolveAll proc {$ Suffix}
                   {Consecutive [7 1 2 3 2 0 1 2 5] 1 3 Suffix}
                end}
 '==' nil}
{Test {SolveAll proc {$ Suffix}
                   {Consecutive [3 1 3 1 1] 3 1 Suffix}
                end}
 '==' [[3 1 1] [1]]}

{StartTesting 'SolveAll backwards'}
{Test {SolveAll proc {$ R}
                   X#Y=R
                in
                   {Consecutive [3 1 3 1 1] X Y [1 1]}
                end}
 '==' [1#3]}

{Test {SolveFirst proc {$ R}
                   X#Y=R
                in
                   {Consecutive [3 1 3 1 1] X Y nil}
                end}
 '==' 1#1}

{Test {SolveFirst proc {$ R}
                     {Consecutive R 3 4 [1 1]}
                  end}
 '==' [3 4 1 1]}

{Test {SolveFirst proc {$ R}
                     {Consecutive R 7 1 [5 6 9]}
                  end}
 '==' [7 1 5 6 9]}

{Test {SolveFirst proc {$ R}
                     R=ok
                     {Consecutive [7 1 5 6 9] 7 1 [5 6 9]}
                  end}
 '==' ok}
